unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Lkuptabl, Dib, Wingpnt, Palette, ExtCtrls, DIBSprit,
  Fasttime, Stringhl, Asteroid, StdCtrls, Sprite, Polygon, Ship, Spin,
  Keyhandl, Missile, Explode, Saucer, Score;

const

  vk_X = $58;
  vk_Z = $5A;

type
  TfrmMain = class(TForm)
    board: TWinGPaintBox;
    dibAthena: TDIB;
    LookupTable1: TLookupTable;
    strPoints: TStringHolder;
    keyboard: TKeyboardHandler;
    Panel1: TPanel;
    grp1: TGroupBox;
    Label1: TLabel;
    lblShips1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    dfScore1: TPanel;
    dfShips1: TPanel;
    grp2: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    dfScore2: TPanel;
    dfShips2: TPanel;
    dibAnders: TDIB;
    dibUs: TDIB;
    Timer1: TFastTimer;
    procedure ftTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure boardWinGPostPaint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    bTimer: boolean;
    lstNew: TList;
    nWave: integer;
    nResize: integer;
    nScore: array[1..2] of longint;
    nLives: array[1..2] of integer;
    procedure CreateSaucer;
    procedure NewWave;
    procedure UpdateStats;
    procedure StartGame;
  public
    ship1, ship2: TShip;
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.ftTimer(Sender: TObject);
begin
  if bTimer then
     Exit;
  bTimer := TRUE;
  board.Paint;
  bTimer := FALSE;
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
  dibAthena.LoadFromBitmap( frmPalette.imAthena.Picture.Bitmap );
  dibAnders.LoadFromBitmap( frmPalette.imAnders.Picture.Bitmap );
  dibUs.LoadFromBitmap( frmPalette.imHallow.Picture.Bitmap );
  with board do
     begin
        PaletteDIB := dibAthena;
        AutoBlank := TRUE;
     end;
  StartGame;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  nResize := 0;
  Randomize;
  lstNew := TList.Create;
end;

(*********************************************
Main Loop
*********************************************)
procedure TfrmMain.boardWinGPostPaint(Sender: TObject);
var
  i: integer;
  spr: TSprite;

  procedure BreakAsteroid( ast: TAsteroid );
  var
     newAsteroid: TAsteroid;
     nNew, nAdd: integer;
  begin
     lstNew.Add( TExplosion.CreateExplosion( ast.Position, 50, Random( 255 ) ) );
     if ast.Size <> asSmall then
        begin
           nAdd := 2;
           if Random( 100 ) > 80 then
              nAdd := 3;
           for nNew := 1 to nAdd do
              begin
                 newAsteroid := TAsteroid.CreateAsteroid( Succ( ast.Size ), LookupTable1 );
                 newAsteroid.Position := ast.Position;
                 newAsteroid.Destination := Point( Random( 5000 ) - 2500, Random( 5000 ) - 2500 );
                 lstNew.Add( newAsteroid );
              end;
        end;
  end;

  procedure CollisionDetectionAsteroid( ast: TAsteroid; s: TShip );
  begin
     if s.bDead then
        Exit;
     if s.InHyperspace then
        Exit;
     if ast.bKill then
        Exit;
     if ast.FudgedDistance( s ) < ast.CollisionDistance + 5 then
        begin
           BreakAsteroid( ast );
           ast.Kill;
           s.DestroyShip( nLives[s.Tag] );
           UpdateStats;
        end;
  end;

  procedure AddScore( i: integer; n: integer );
  var
     nOld: integer;
  begin
     nOld := nScore[i] div 10000;
     Inc( nScore[i], n );
     if nScore[i] div 10000 > nOld then
        Inc( nLives[i] );
     UpdateStats;
  end;

  procedure CollisionDetectMissile;
  var
     k: integer;
     spr_: TSprite;
  begin
     if spr.bKill then
        Exit;
     for k := 0 to board.lstSprites.Count - 1 do
        begin
           spr_ := TSprite( board.lstSprites[k] );
           if ( spr_ is TSaucer ) and ( spr.Tag <> 99 ) then
              begin
                 if spr.FudgedDistance( spr_ ) < 30 then
                    begin
                       spr.Kill;
                       spr_.Kill;
                       AddScore( spr.Tag, ( spr_ as TSaucer ).Score );
                       lstNew.Add( TExplosion.CreateExplosion( spr.Position, 75, Random( 255 ) ) );
                    end;
              end
           else if spr_ is TAsteroid then
              if spr.FudgedDistance( spr_ ) < TAsteroid( spr_ ).CollisionDistance then
                 begin
                    spr.Kill;
                    spr_.Kill;
                    with spr_ as TAsteroid do
                       begin
                          if spr.Tag <> 99 then
                             AddScore( spr.Tag, Score );
                          BreakAsteroid( spr_ as TAsteroid );
                       end;
                    Exit;
                 end;
        end;
  end;

  procedure ProcessShip( s: TShip; cLeft, cRight: char; cFire,
     cThrust, cHyper: integer );
  begin
     if not s.InHyperspace then
        begin
{ Check rotation }
           if keyboard[cLeft] then
              s.Spin := rotCounterClockwise
           else if keyboard[cRight] then
              s.Spin := rotClockwise
           else
              s.Spin := rotNone;

{ Check fire }
           if s.CanFire then
              begin
                 if keyboard.VirtualKeyDown[cFire] then
                    s.Fire;
              end
           else
              if not keyboard.VirtualKeyDown[cFire] then
                 s.StopFire;

{ Check thrust }

           s.Thrusting := keyboard.VirtualKeyDown[cThrust];

{ Check hyperspace }
           if keyboard.VirtualKeyDown[cHyper] then
              s.HyperSpace;

        end;
  end;

  procedure CollisionDetectionSaucer( s: TSaucer );
  var
     i: integer;
     spr_: TSprite;
  begin
     for i := 0 to board.lstSprites.Count - 1 do
        begin
           spr_ := TSprite( board.lstSprites[i] );
           if spr_ is TShip then
              begin
                 if s.FudgedDistance( spr_ ) < 30 then
                    if not ( spr_ as TShip ).bDead and not ( spr_ as TShip ).InHyperSpace
                       and not ( spr_ as TShip ).Invulnerable then
                       begin
                          ( spr_ as TShip ).DestroyShip( nLives[spr_.Tag] );
                          s.Kill;
                          UpdateStats;
                          Exit;
                       end;
              end
           else if spr_ is TAsteroid then
              begin
                 if s.FudgedDistance( spr_ ) < 30 then
                    begin
                       BreakAsteroid( spr_ as TAsteroid );
                       s.Kill;
                       Exit;
                    end;
              end;
        end;
  end;

  procedure CollisionDetectSaucerMissile( m: TMissile; s: TShip );
  begin
     if s.bDead or m.bKill or s.InHyperSpace then
        Exit;
     if m.FudgedDistance( s ) < 8 then
        begin
           lstNew.Add( TExplosion.CreateExplosion( m.Position, 75, Random( 255 ) ) );
           s.DestroyShip( nLives[s.Tag] );
           m.Kill;
           UpdateStats;
           Exit;
        end;
  end;

begin
  if not timer1.Enabled then
     Exit;

  if not ship1.bDead then
     ProcessShip( ship1, 'a', 's', vk_X, vk_Z, vk_Escape );
  if not ship2.bDead then
     ProcessShip( ship2, 'k', 'l', vk_Control, vk_Shift, vk_F12 );

{ Clear list of new sprites }
  lstNew.Clear;

{ Check for collisions }
  for i := 0 to board.lstSprites.Count - 1 do
     begin
        spr := TSprite( board.lstSprites[i] );
        if ( spr is TMissile ) and ( spr.Tag = 99 ) then
           begin
              if not ship1.Invulnerable then
                 CollisionDetectSaucerMissile( spr as TMissile, ship1 );
              if not ship2.Invulnerable then
                 CollisionDetectSaucerMissile( spr as TMissile, ship2 );
           end;
        if spr is TMissile then
           CollisionDetectMissile
        else if spr is TSaucer then
           CollisionDetectionSaucer( spr as TSaucer )

        else if spr is TAsteroid then
           begin
              if not ship1.Invulnerable then
                 CollisionDetectionAsteroid( spr as TAsteroid, ship1 );
              if not ship2.Invulnerable then
                 CollisionDetectionAsteroid( spr as TAsteroid, ship2 );
           end;
     end;

{ Register new sprites that were created }
  for i := 0 to lstNew.Count - 1 do
     TSprite( lstNew[i] ).RegisterSprite( board );

{ See if new wave or end of game }
  if ( ship1.bDead and ship2.bDead ) then
     begin
        timer1.Enabled := FALSE;
        ShowMessage( '* * G A M E   O V E R * *' );
        frmScores.CheckHighScore( nScore[1], '1' );
        frmScores.CheckHighScore( nScore[2], '2' );
        frmScores.ShowModal;
        if MessageDlg( 'Play Again?', mtConfirmation, [mbYes,mbNo], 0 ) = mrYes then
           StartGame
        else
           Application.Terminate;
     end
  else
     if board.lstSprites.Count = 2 then
        NewWave;

{ Create saucers? }
  if Random( 20000 ) < ( nWave shl 4 ) then
     CreateSaucer;

end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  lstNew.Clear;
  lstNew.Free;
end;

procedure TfrmMain.NewWave;
var
  i: integer;
begin
  timer1.Enabled := FALSE;
  ShowMessage( 'Get Ready for Wave ' + IntToStr( nWave ) );
  for i := 1 to ( 2 + nWave ) do
     with TAsteroid.CreateAsteroid( asBig, LookupTable1 ) do
        begin
           Position := Point( Random( board.PhysicalWidth ), Random( board.PhysicalHeight ) );
           Destination := Point( Random( 5000 ) - 2500, Random( 5000 ) - 2500 );
           RegisterSprite( board );
        end;
  if ship1 <> nil then
  with ship1 do
     begin
        Position := Point( board.PhysicalWidth div 2 - 100, board.PhysicalHeight div 2 );
        nSpeedX := 0;
        nSpeedY := 0;
        Angle := 0;
        Invulnerable := TRUE;
     end;
  if ship2 <> nil then
  with ship2 do
     begin
        Position := Point( board.PhysicalWidth div 2 + 100, board.PhysicalHeight div 2 );
        nSpeedX := 0;
        nSpeedY := 0;
        Angle := 0;
        Invulnerable := TRUE;
     end;
  Caption := 'WinRocks - Delphi Edition - Wave ' + IntToStr( nWave );
  Inc( nWave );
  timer1.Enabled := TRUE;
end;

procedure TfrmMain.StartGame;
var
  i: integer;
begin
  for i := 0 to board.lstSprites.Count - 1 do
     TSprite( board.lstSprites[i] ).Free;
  board.lstSprites.Clear;

  timer1.Enabled := TRUE;

  nWave := 1;
  nScore[1] := 0;
  nScore[2] := 0;
  nLives[1] := 3;
  nLives[2] := 3;

  ship1 := TShip.CreatePolygonSprite( 137, LookupTable1 );
  ship2 := TShip.CreatePolygonSprite( 30, LookupTable1 );
  with ship1 do
     begin
        Position := Point( board.PhysicalWidth div 2 - 100, board.PhysicalHeight div 2 );
        Speed := 10;
        SpinSpeed := 5;
        Tag := 1;
        Invulnerable := TRUE;
        RegisterSprite( board );
     end;
   with ship2 do
     begin
        Position := Point( board.PhysicalWidth div 2 + 100, board.PhysicalHeight div 2 );
        Speed := 10;
        SpinSpeed := 5;
        Tag := 2;
        Invulnerable := TRUE;
        RegisterSprite( board );
     end;
  NewWave;
end;

procedure TfrmMain.FormResize(Sender: TObject);
begin
  Inc( nResize );
{ The first resize occurs on create ... ignore this one!! }
  if nResize = 1 then
     Exit;

  board.Width := ClientWidth - board.Left * 2 - panel1.Width;
  board.Height := ClientHeight - board.Top * 2;
end;

procedure TfrmMain.CreateSaucer;
var
  d: TSaucer;
begin
  d := TSaucer.CreateSaucer( nWave );
  d.RegisterSprite( board );
end;

procedure TfrmMain.UpdateStats;
begin
  dfScore1.Caption := IntToStr( nScore[1] );
  dfScore2.Caption := IntToStr( nScore[2] );
  dfShips1.Caption := IntToStr( nLives[1] );
  dfShips2.Caption := IntToStr( nLives[2] );
end;

end.
